# AttributeExtraction

This is a short demo for automatic attribute extraction from semi structured text using SpaCY.

See https://spacy.io/usage/spacy-101 for a general intro to SpaCY and NLP and https://spacy.io/api for the library's architecture.

The project uses SpaCY's NER and matcher:
- Documentation on NER: https://spacy.io/api/entityrecognizer
- The matcher's documentation is found here: https://spacy.io/usage/rule-based-matching#matcher
- To test your matcher patterns, use this tool: https://demos.explosion.ai/matcher

## Setup
- install Python Version 3.6 to 3.9  
- Install Spacy:  
    `pip install -U pip setuptools wheel --user`  
    `pip install -U spacy --user`  
- Install the model/pipeline:  
    - For speed:  
    `python -m spacy download en_core_web_sm`  
    - For accuracy:   
    `python -m spacy download en_core_web_trf`

For more details on configuring your spacy installation, see: https://spacy.io/usage 

## Getting started
This project contains the following elements:

- script.py: the main Python script.
- SensorData.txt: Contains GTP-4o generated test data in a comma-separated list format
- SensorDataComplex.txt: contains GTP-4o generated test data in sentence format with natural language descriptions.
- ProductIDs.txt: Reference data to test against
- results.json: Contains the results and some additional data for evaluation, such as the extraction method used.
- results.csv: The results formatted as csv.
- results.excel: An excel importing the data from the results.csv
- visualisations folder: Contains the visualisations of the NER results and the full dependencies. Successful matches are stored in 'matches' and unsuccessful extractions in 'mismatches'.
